NeuralEngine A Game Engine with embeded Machine Learning algorithms based on Gaussian Processes. |

Classes | Typedefs | Enumerations | Functions
NeuralEngine Namespace Reference

## Classes
class | Array2
| The Array2 class represents a 2-dimensional array that minimizes the number of new and delete calls. The T objects are stored in a contiguous array. More...
class | Array3
| The Array3 class represents a 3-dimensional array that minimizes the number of new and delete calls. The T objects are stored in a contiguous array. More...
class | Array4
| The Array4 class represents a 4-dimensional array that minimizes the number of new and delete calls. The T objects are stored in a contiguous array. More...
class | ComputeModel
| Core item ComputeModel. More...
class | EFStream
class | Environment
class | LexicoArray2
class | LexicoArray2< false, Real >
class | LexicoArray2< true, Real >
class | Listener
class | Logger
class | LogReporter
class | LogToFile
class | LogToMessageBox
class | LogToOutputWindow
class | LogToStdout
class | LogToStringArray
class | MatlabIO
| Matlab Mat file parser for C++ OpenCV. More...
class | MatlabIOContainer
| A container class for storing type agnostic variables. More...
class | MinHeap
| Minimum heap binary tree. More...
class | ReversalObject
| Reversal object. More...
class | ThreadSafeMap
class | ThreadSafeQueue
class | Timer
struct | TypeName
struct | TypeName< bool >
struct | TypeName< char >
struct | TypeName< cv::Mat >
struct | TypeName< double >
struct | TypeName< float >
struct | TypeName< int16_t >
struct | TypeName< int32_t >
struct | TypeName< int64_t >
struct | TypeName< int8_t >
struct | TypeName< MatlabIOContainer >
struct | TypeName< std::vector< cv::Mat > >
struct | TypeName< std::vector< MatlabIOContainer > >
struct | TypeName< std::vector< std::vector< MatlabIOContainer > > >
struct | TypeName< uint16_t >
struct | TypeName< uint32_t >
struct | TypeName< uint64_t >
struct | TypeName< uint8_t >
struct | TypeName< void >
class | Util
| A Utility class. More...

## Typedefs
typedef std::vector< MatlabIOContainer > | vectorMatlabIOContainer
typedef std::vector< std::vector< MatlabIOContainer > > | vector2DMatlabIOContainer

## Enumerations
enum | { VERSION_5 = 5 , VERSION_73 = 73 }
enum | { MAT_INT8 = 1 , MAT_UINT8 = 2 , MAT_INT16 = 3 , MAT_UINT16 = 4 , MAT_INT32 = 5 , MAT_UINT32 = 6 , MAT_FLOAT = 7 , MAT_DOUBLE = 9 , MAT_INT64 = 12 , MAT_UINT64 = 13 , MAT_MATRIX = 14 , MAT_COMPRESSED = 15 , MAT_UTF8 = 16 , MAT_UTF16 = 17 , MAT_UTF32 = 18 }
enum | { MAT_CELL_CLASS = 1 , MAT_STRUCT_CLASS = 2 , MAT_OBJECT_CLASS = 3 , MAT_CHAR_CLASS = 4 , MAT_SPARSE_CLASS = 5 , MAT_DOUBLE_CLASS = 6 , MAT_FLOAT_CLASS = 7 , MAT_INT8_CLASS = 8 , MAT_UINT8_CLASS = 9 , MAT_INT16_CLASS = 10 , MAT_UINT16_CLASS = 11 , MAT_INT32_CLASS = 12 , MAT_UINT32_CLASS = 13 , MAT_INT64_CLASS = 14 , MAT_UINT64_CLASS = 15 }

## Functions
template<typename T >
T | AtomicMin (std::atomic< T > &v0, T const &v1)
| Implementations of atomic minimum and atomic maximum computations. These are based on std::atomic_compare_exchange_strong. More...
template<typename T >
T | AtomicMax (std::atomic< T > &v0, T const &v1)
template<typename Iterable , typename Iterator = decltype(std::begin(std::declval<Iterable>())), typename ReverseIterator = std::reverse_iterator<Iterator>>
ReversalObject< ReverseIterator > | reverse (Iterable &&range)
void NE_IMPEXP | Memcpy (void *target, void const *source, size_t count)
void NE_IMPEXP | Memcpy (wchar_t *target, wchar_t const *source, size_t count)

## Detailed Description

File: NECore/DataTypes/NeArray2.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/DataTypes/NeArray3.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/DataTypes/NeArray4.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/DataTypes/NeAtomicMinMax.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/DataTypes/NeComputeModel.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeEFStream.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NEApplications/Application/NeEnvironment.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/DataTypes/NeLexicoArray2.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeLogger.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeLogReporter.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeLogToFile.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeLogToMessageBox.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeLogToOutputWindow.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeLogToStdout.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeLogToStringArray.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: Core/InputOutput/NeMatlabIO.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeMatlabIOContainer.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/DataTypes/NeMinHeap.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/DataTypes/NeReversalObject.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/Threading/NeThreadSafeMap.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/Threading/ThreadSafeQueue.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/Time/NeTimer.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/InputOutput/NeTypetraits.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: Core/NeUtil.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: NECore/Memory/NeWrapper.h

Author:
Email:
Site:

Copyright (c) 2016 . All rights reserved.

File: MachineLearning/Optimization/Base/BaseGradientOptimizationMethod.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Optimization/Base/IGradientOptimizationMethod.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Util/CommonUtil.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/FgAdaMaxSolver.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/FgAdamSolver.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgAEPSparseDGPLVM.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgAEPSparseDGPR.h

Author:
Email:
Site:

Copyright (c) 2018 . All rights reserved.

File: MachineLearning/GPModels/SparseGPModels/AEP/FgAEPSparseGPLayer.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgAEPSparseGPLVM.h

Author:
Email:
Site:

Copyright (c) 2018 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgAEPSparseGPR.h

Author:
Email:
Site:

Copyright (c) 2018 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgAEPSparseGPSSM.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Util/FgKMeans.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Kernel/FgRBFKernel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/Linesearch/FgArmijoBracketingLineSearch.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/Linesearch/Armijo.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgAEPSparseGPR.h

Author:
Email:
Site:

Copyright (c) 2022 . All rights reserved.

File: MachineLearning/Util/CVPlot/FgColor.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Kernel/FgCompoundKernel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Models/GPModels/FgDeepGPBaseModel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Node/FgDiscreteFactorNode.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Graph/FgDiscreteGraph.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Message/FgGaussianMessage.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Node/FgDiscreteVariableNode.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Util/FgEigenvalueDecomposition.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Util/CVPlot/FgFigure.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/Layers/EmissionLayers/FgGaussEmissionLayer.h

Author:
Email:
Site:

Copyright (c) 2022 . All rights reserved.

File: MachineLearning/Util/FgGaussHermiteQuadrature.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/Layers/FgGaussLikelihoodLayer.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/Layers/GPLayers/FgGPBaseLayer.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Models/GPModels/FgGPBaseModel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/FactorGraph/Node/FgGPNode.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Models/GPModels/FgGPStateSpaceBaseModel.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Util/CVPlot/FgHighGUI.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Backconstraints/FgIBackconstraints.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Graph/Node/FgIFactorNode.cpp

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/FgIGraph.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Kernel/FgIKernel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/Layers/LikLayers/FgILikelihoodLayer.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Message/FgIMessage.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/FgIModel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Node/FgINode.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Embed/FgLLE.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Node/FgIVariableNode.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Backconstraints/FgKernelBasedRegression.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Util/FgKMeans.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/FgLBFGS.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/L-BFGS.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Kernel/FgLinearAccelerationKernel.h

Author: Nick Taubert Email: nick..nosp@m.taub.nosp@m.ert@u.nosp@m.ni-t.nosp@m.uebin.nosp@m.gen..nosp@m.de Site: http://www.compsens.uni-tuebingen.de/

Copyright (c) 2017 CompSens. All rights reserved.

File: MachineLearning/Kernel/FgLinearKernel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Graph/Message/FgMessageBox.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Util/FgMetrics.h

Author:
Email:
Site:

Copyright (c) 2022 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/Linesearch/FgMoreThuenteLineSearch.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/FgNadamSolver.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Embed/PCA.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/SparseGPModels/PowerEP/FgPEPSparseGPLayer2nd.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgPEPSparseGPLVM.h

Author:
Email:
Site:

Copyright (c) 2018 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgPEPSparseGPR.h

Author:
Email:
Site:

Copyright (c) 2018 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgPEPSparseGPR2nd.h

Author:
Email:
Site:

Copyright (c) 2018 . All rights reserved.

File: MachineLearning/GPModels/Backconstraints/FgPeriodicTopologicalConstraint.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Graph/Misc/FgPotential.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/Layers/FgProbitLikelihoodLayer.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Kernel/FgRBFAccelerationKernel.h

Author: Nick Taubert Email: nick..nosp@m.taub.nosp@m.ert@u.nosp@m.ni-t.nosp@m.uebin.nosp@m.gen..nosp@m.de Site: http://www.compsens.uni-tuebingen.de/

Copyright (c) 2017 CompSens. All rights reserved.

File: MachineLearning/Kernel/FgRBFKernel.h

Author: Nick Taubert Email: nick..nosp@m.taub.nosp@m.ert@u.nosp@m.ni-t.nosp@m.uebin.nosp@m.gen..nosp@m.de Site: http://www.compsens.uni-tuebingen.de/

Copyright (c) 2017 CompSens. All rights reserved.

File: MachineLearning/Optimization/Constrained/ScaledConjugateGradient.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Models/GPModels/FgSparseDeepGPBaseModel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Models/GPModels/FgSparseDeepGPLVMBaseModel.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Models/GPModels/FgSparseDeepGPSSMBaseModel.h

Author:
Email:
Site:

Copyright (c) 2022 . All rights reserved.

File: MachineLearning/GPModels/SparseGPModels/SparseGPBaseLayer.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Models/GPModels/FgSparseGPBaseModel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Models/GPModels/FgSparseGPLVMBaseModel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Models/GPModels/FgSparseGPSSMBaseModel.h

Author:
Email:
Site:

Copyright (c) 2020 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/Linesearch/FgStrongWolfeBacktrackingLineSearch.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Kernel/FgStyleKernel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Kernel/FgTensorKernel.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/SparseGPModels/VFE/FgVFESparseGPLayer.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgVFESparseGPLVM.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/GPModels/Models/GPModels/FgVFESparseGPR.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Kernel/FgWhiteKernel.h

Author: Nick Taubert Email: nick..nosp@m.taub.nosp@m.ert@u.nosp@m.ni-t.nosp@m.uebin.nosp@m.gen..nosp@m.de Site: http://www.compsens.uni-tuebingen.de/

Copyright (c) 2017 CompSens. All rights reserved.

File: MachineLearning/Util/CVPlot/FgWindow.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/Linesearch/FgWolfeBacktrackingLineSearch.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Optimization/Unconstrained/Linesearch/FgWolfeBracketingLineSearch.h

Author:
Email:
Site:

Copyright (c) 2019 . All rights reserved.

File: MachineLearning/Embed/IEmbed.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Optimization/IObjectiveFunction.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

afaf::array File: MachineLearning/Optimization/Base/IIOptimizationMethod.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

File: MachineLearning/Optimization/NonlinearObjectiveFunction.h

Author:
Email:
Site:

Copyright (c) 2017 . All rights reserved.

## Typedef Documentation

## ◆ vectorMatlabIOContainer

typedef std::vector<MatlabIOContainer> NeuralEngine::vectorMatlabIOContainer

Definition at line 21 of file NeMatlabIOContainer.h.

## ◆ vector2DMatlabIOContainer

typedef std::vector<std::vector<MatlabIOContainer> > NeuralEngine::vector2DMatlabIOContainer

Definition at line 22 of file NeMatlabIOContainer.h.

## Enumeration Type Documentation

## ◆ anonymous enum

anonymous enum

Definition at line 26 of file NeMatlabIO.h.

## ◆ anonymous enum

anonymous enum

Definition at line 22 of file NeTypetraits.h.

## ◆ anonymous enum

anonymous enum

Definition at line 40 of file NeTypetraits.h.

## Function Documentation

## ◆ AtomicMin()

template<typename T >

T NeuralEngine::AtomicMin | ( | std::atomic< T > & | v0,
|  | T const & | v1
| ) |  |

Implementations of atomic minimum and atomic maximum computations. These are based on std::atomic_compare_exchange_strong.

Definition at line 34 of file NeAtomicMinMax.h.

## ◆ AtomicMax()

template<typename T >

T NeuralEngine::AtomicMax | ( | std::atomic< T > & | v0,
|  | T const & | v1
| ) |  |

Definition at line 46 of file NeAtomicMinMax.h.

## ◆ reverse()

template<typename Iterable , typename Iterator = decltype(std::begin(std::declval<Iterable>())), typename ReverseIterator = std::reverse_iterator<Iterator>>

ReversalObject< ReverseIterator > NeuralEngine::reverse | ( | Iterable && | range | ) |

Definition at line 73 of file NeReversalObject.h.